#include <iostream>  
#include <assert.h>  
using namespace std;

#define MAXSTR 100


enum species_t {
	dog,
	cat,
	horse,
	parrot
};

struct pet_t {

	char name[MAXSTR];
	int age;
	species_t type;

};

const char * species_name(species_t s)
{
	switch (s) {
		case dog: return "Dog";
		case cat: return "Cat";
		case horse: return "Horse";
		case parrot: return "Parrot";
		default: assert(false); // I'm confused by how you got here.
	}
}

void print_pet(pet_t *pet)
{
	assert(pet != NULL);	
	cout << " -------------------------------" << endl;
	cout << " Name : " << pet->name << endl;
	cout << " Age : " << pet->age << endl;
	cout << " Type : " << species_name(pet->type) << endl;
	cout << " -------------------------------" << endl;

}

species_t get_species()
{
	while (true)
	{
		char c;
		cin >> c;
		switch (c)
		{
			case 'D':
			case 'd': return dog;
			case 'C':
			case 'c': return cat;
			case 'H':
			case 'h': return horse;
			case 'P':
			case 'p': return parrot;


			default:
				cerr << "Please enter one of [D, C, H, P]!" << endl;
		}
	}

}

void set_pet_data_from_input(pet_t *pet)
{
	assert(pet != NULL);	
	cout << "What's this pet's name:" << endl;
	cin >> pet->name;
	cout << "What's " << pet->name << "'s age:" << endl;
	cin >> pet->age;
	cout << "What's " << pet->name << "'s species type [D,C,H,P]:" << endl;
	pet->type = get_species();

}


pet_t *get_pets(int &count_pets)
{
	cout << "How many animals do you have?" << endl;
	cin >> count_pets;

	if (count_pets == 0)
		return NULL;

	pet_t *all_animals = new pet_t[count_pets];
			// allocate a fresh collection of pet_t's
			// that should be a block of count_pets in total

	for (int c = 0; c < count_pets; c++)
		set_pet_data_from_input(&all_animals[c]);


	return all_animals;

}

int main(int argc, char **argv)
{

	pet_t *my_pets;
	int count_pets;
	my_pets = get_pets(count_pets);


	if (count_pets > 0)
	{
		for (int i = 0; i < count_pets; i++)
			print_pet(&my_pets[i]);

		cout << "my_pets  : " << my_pets << endl;
		cout << "&my_pets[0]  : " << &my_pets[0] << endl;

		// delete my_pets; // delete only first element
		delete [] my_pets; // delete the dynamically allocated array
	}
	else
		cout << "Visit a shelter and pick one out!" << endl;

	return 0;
}

